// DESC2.H  Second descent procedure for use with descent via 2-isogeny

int desc2(const bigint& c, const bigint& d1, const bigint& d2,
	  const vector<bigint>& plist, const vector<bigint>& supp, const vector<bigint>& bgens,
	  long mask,  double hlim,
	  bigint& x, bigint& y, bigint& z, int verb, int selmer_only=0, int alldesc=0);
// Works on homogeneous space (d1,0,c,0,d2)
// Returns 
//   -1 if it certainly has no points (if no ELS descendents)
//   +1 if it has a point (coordinates returned in x, y, z)
//    0 if undecided (ELS descendents exist but no rational points were found)
// if alldesc==1 it does not stop when it finds one descendent with a point on it,
// but goes on to look at all the others.
