//
// divpol.h: definition of various polynomial functions for division
// polynomials etc
//

// allow for multiple includes
#ifndef _DIVPOL_
#define _DIVPOL_

// These functions return the vector of coefficients (starting with
// the constant term rather than polynomial types (which depend on
// whether NTL or LiDIA is being used)

// div_pol_odd(a1,a2,a3,a4,a6,n) returns the coefficients of the
// polynomial in x whose zeros are the (x-coordinates of the) non-zero
// points P on E=[a1,a2,a3,a4,a6] satisfying nP=0 (odd n)

// The poly itself is found recursively

vector<bigint> div_pol_odd(const bigint& a1,const bigint& a2,const bigint& a3,const bigint& a4,
			   const bigint& a6,int n); 


vector<bigint> makepdivpol(Curvedata* EE, int p);

#endif
