#include "mquartic.h"

// Checks for solublility in Qp:

int qpsoluble(const quartic& g, const bigint& p); 
int qpsoluble(const bigint& a, const bigint& b, const bigint& c, const bigint& d, 
	      const bigint& e, const bigint& p);
int qpsoluble(const bigint& a, const bigint& c, const bigint& e, const bigint& p);
// latter assumes b=d=0



// Checks for local solubility in Qp for all p in plist; 
//if not, badp will hold the first p for which NOT soluble in Qp:

int locallysoluble(const quartic& g, const vector<bigint>& plist, bigint& badp);
int locallysoluble(const bigint& a, const bigint& b, const bigint& c, const bigint& d, 
	      const bigint& e, const vector<bigint>& plist, bigint& badp);
int locallysoluble(const bigint& a, const bigint& c, const bigint& e, 
		   const vector<bigint>& plist, bigint& badp);
// latter assumes b=d=0


// The following will only be properly defined if LiDIA_INTS is
// defined, otherwise they just call the old ones.

/* Samir Siksek's Local Solubility Test for odd p */

int local_sol(const bigint& p,bigint *c, int verbose=0);

 // Checks for solublility in Qp 
int new_qpsoluble(const quartic& g, const bigint& p, int verbose=0);
int new_qpsoluble(const bigint& a, const bigint& b, const bigint& c, 
		  const bigint& d, const bigint& e, 
		  const bigint& p, int verbose=0);
int new_qpsoluble(const bigint& a, const bigint& c, const bigint& e, 
		  const bigint& p, int verbose=0);

int new_zpsol(const bigint& a,const bigint& b,const bigint& c,const bigint& d,
	      const bigint& e, const bigint& p, int verbose=0);
