// reader.h: class for reading curves from file/tty
//
#include <fstream>
#define TTY "/dev/tty"

class CurveReader {
private:
  int tty_input;
  ifstream in;
public:
  CurveReader(char* name = "")
  {  
    tty_input=0;
    char * filename = new char[32];
    if(!strcmp(name,""))
      {
	cerr << "Enter a filename for curve input (or tty): ";
	cin >> filename;
	cerr<<"filename entered is "<<filename<<endl;
	tty_input = !strcmp(filename,"tty");
      }
    else
      {
	strcpy(filename,name);
      }
    if(tty_input)
      cerr<<"Taking input from terminal"<<endl;
    else
      {
	cerr<<"using filename "<<filename<<endl;
	in.open(filename);
	if(!in) 
	  {
	    cerr<<"Failed to open input file "<<filename<<endl;
	    exit(1);
	  }
	delete[] filename;
      }
  }
  ~CurveReader() {if(!tty_input) in.close();}
  int operator>>(Curve& c)
  {
    if(tty_input)
      {
	cerr<<"Enter a curve (null to exit): "<<flush;
	cin>>c;
      }
    else in >> c;
    return !c.isnull();
  }
};
