//
// sifter.h: definition of class for sifting E(Q)/2E(Q), used for
// proving that points are independent
//

// allow for multiple includes
#ifndef _SIFTER_
#define _SIFTER_


class sifter {
private: 
  Curvedata *E;
  bigint I, J, disc;
  bigint r,s,t;    // tranforms E to E_{I,J} (u=6)
  int rank;
  int verbose;

  int num_aux, max_dim_im;
  int ** eps_mat;
  int * pivcols;
  long * auxs; long * all_p; int * nroots;  
  long ** thetamod;  int**squares;  
  void init();  // define  auxiliary moduli and squares
  void clear();     // free memory
public:
  sifter(Curvedata* EE, int na, int verb=0)
    :E(EE), rank(0), verbose(verb), num_aux(na)
    {
      I = getc4(*E);
      J = 2*getc6(*E);
      disc = getdiscr(*E);
      E->getai(s,r,t,r,r); // r is just a dummy here
      r = 3*getb2(*E);     // this is its real value
      s = 3*s;
      t = 108*t;
      init();
    }
  ~sifter()
    {
      clear();
    }
  int code(const bigint& x, const bigint& z2, int i);
  int * eps(const bigint& x, const bigint& z2);
  void process(const Point& P);
  void process(const vector<Point>& Plist);
  int getrank() {return rank;}
  void vecout(int* v);
};


#endif
